class Remove {
    duplicateLegacy(array) {
        const unique = array.filter((item, index) => array.indexOf(item) === index);
        return unique.sort();
    }
    async duplicate(array, sort = false, asc = true) {
        const arrayWithoutDuplicates = [...new Set(array)];
        if (sort) {
            return await ArraySort.get(arrayWithoutDuplicates, asc);
        }
        else {
            return arrayWithoutDuplicates;
        }
    }
    async duplicatedByKey(data, identification, sortIdentification, asc = true) {
        const array = [];
        for (const item of data) {
            array.push(item[identification]);
        }
        const singleArrayWithoutDuplicates = [...new Set(array)];
        const arrayWithoutDuplicates = [];
        singleArrayWithoutDuplicates.forEach((item) => {
            const i = data.filter(x => x[identification] === item)[0];
            arrayWithoutDuplicates.push(i);
        });
        if (sortIdentification != null) {
            return await ArraySort.byKey(arrayWithoutDuplicates, sortIdentification, asc);
        }
        else {
            return arrayWithoutDuplicates;
        }
    }
    async notDuplicated(array, asc = true) {
        const arrayWithoutDuplicates = [...new Set(array)];
        let duplicates = [...array];
        arrayWithoutDuplicates.forEach((item) => {
            const i = duplicates.indexOf(item);
            duplicates = duplicates
                .slice(0, i)
                .concat(duplicates.slice(i + 1, duplicates.length));
        });
        return await ArraySort.get(duplicates, asc);
    }
    async notDuplicatedByKey(data, identification, sortIdentification, asc = true) {
        const array = [];
        for (const item of data) {
            array.push(item[identification]);
        }
        const arrayWithoutDuplicates = [...new Set(array)];
        let duplicates = [...array];
        arrayWithoutDuplicates.forEach((item) => {
            const i = duplicates.indexOf(item);
            duplicates = duplicates
                .slice(0, i)
                .concat(duplicates.slice(i + 1, duplicates.length));
        });
        if (sortIdentification != null) {
            return await ArraySort.byKey(duplicates, sortIdentification, asc);
        }
        else {
            return duplicates;
        }
    }
}
export const ArrayRemove = new Remove();
class Sort {
    async get(array, asc) {
        return new Promise(resolve => {
            const _asc = asc ? 1 : -1;
            const sorted = array.sort((a, b) => {
                const x = a;
                const y = b;
                return (x === y) ? 0 : ((x > y) ? _asc : -1 * _asc);
            });
            resolve(sorted);
        });
    }
    async byKey(array, key, asc) {
        return new Promise(resolve => {
            const _asc = asc ? 1 : -1;
            const sorted = array.sort((a, b) => {
                const x = a[key];
                const y = b[key];
                return (x === y) ? 0 : ((x > y) ? _asc : -1 * _asc);
            });
            resolve(sorted);
        });
    }
    async moveArray(array, from, to) {
        const item = array[from];
        const newArray = [...array];
        newArray[from] = array[to];
        newArray[to] = item;
        for (const [i, arrayItem] of newArray.entries()) {
            arrayItem.id = i;
        }
        return newArray;
    }
}
export const ArraySort = new Sort();
//# sourceMappingURL=core-services-array.service.js.map